jQuery(document).ready(function($) {
  $(".colors_picker").spectrum({
    showInput: true,
    preferredFormat: "hex",
    clickoutFiresChange: true,
    cancelText: "cancel"
  });
  $("#all_statuses, #selected_statuses_success,#selected_statuses_failed")
    .sortable({
      connectWith: ".connected",
      update: function(event, ui) {
        $("#wc_statuses option").remove();
        var html = "";
        $("ul#selected_statuses_success li").each(function(i, el) {
          var title = $(el)
            .text()
            .trim();
          var key = $(el).attr("data-id");
          console.log(title);
          html +=
            '<input type="hidden" value="' +
            title +
            '" name="anwc_order_progressbar[wc_statuses][success][' +
            key +
            ']">';
        });
        $("ul#selected_statuses_failed li").each(function(i, el) {
          var title = $(el)
            .text()
            .trim();
          var key = $(el).attr("data-id");
          console.log(title);
          html +=
            '<input type="hidden" value="' +
            title +
            '" name="anwc_order_progressbar[wc_statuses][failed][' +
            key +
            ']">';
        });
        $("#wc_statuses").html(html);
        $("#border_color").change();
      }
    })
    .disableSelection();

  $("form input,form select").change(function() {
    preview();
  });

  $(".is_page").click(function() {
    var checked = $(this).is(":checked");
    if (checked) {
      $(this)
        .parent()
        .next(".placements")
        .show("slow");
    } else {
      $(this)
        .parent()
        .next(".placements")
        .hide("slow");
    }
  });
  $(".is_page:checked")
    .parent()
    .next(".placements")
    .show("slow");

  $("#hide-preview").click(function() {
    $("#anwcpb_preview > div").toggle("slide");
  });
  preview();
});

function preview() {
  //jQuery('#anwcpb_preview').html('');

  var stages = {};
  stages_arr = get_stages_object();
  console.log(stages_arr);
  for (tx in stages_arr) {
    var color = jQuery("#color_" + tx).val();
    var bgcolor = jQuery("#bgcolor_" + tx).val();
    var theme = jQuery("#theme_" + tx).val();
    var border_width = jQuery("#border_width").val();
    var border_style = jQuery("#border_style").val();
    var border_color = jQuery("#border_color").val();
    var border_radius = jQuery("#border_radius").val();
    var is_shadow = jQuery("#is_shadow").is(":checked");
    var shadow = "";
    if (is_shadow) {
      shadow = "box-shadow:0px 3px 5px;";
    }
    if (jQuery.inArray(theme, default_themes) >= 0) {
      jQuery("#anwcpb_preview ." + tx).html("");
      
        stages_arr[tx] = jQuery.extend(
          {},
          { "wc-ordered": "Ordered"},
          stages_arr[tx]
        );
      
      var stages = stages_arr[tx];
      var stage_key = Object.keys(stages)[Object.keys(stages).length - 2];
      var stage = stages[stage_key];
      console.log(stage_key);
      if (stage_key in stages) {
        var stage_scores = {};
        var stage_name_html = "";
        var x = 0;
        for (i in stages) {
          var unit = 100 / (Object.keys(stages).length - 1);
          stage_scores[stages[i]] = unit * x ? unit * x : 7;
          stage_name_html +=
            '<span class="' +
            (stage == stages[i] ? "current" : "") +
            '" style="right:' +
            (100 - unit * x) +
            '%">' +
            stages[i] +
            "</span>";
          x++;
        }
        console.log(stage_scores);
        var order_number = "#11"; //$('mark.order-number').text();
        order_number = order_number.trim();
        order_number = order_number.replace("#", "");
        //alert(stage);
        jQuery("#anwcpb_preview ." + tx).append(
          "<style id='anwc_progress_bar_" +
            tx +
            "-inline-css' type='text/css'>." +
            tx +
            " .meter:after {border-color:" +
            shadeColor(color, -0.3) +
            " !important;-moz-border-radius: " +
            border_radius +
            "px;-webkit-border-radius: " +
            border_radius +
            "px;border-radius: " +
            border_radius +
            "px; } ." +
            tx +
            " .meter span:after{background:" +
            shadeColor(color, -0.3) +
            " !important;-moz-border-radius: " +
            border_radius +
            "px;-webkit-border-radius: " +
            border_radius +
            "px;border-radius: " +
            border_radius +
            "px; }." +
            tx +
            " .meter{ background:" +
            bgcolor +
            ";-moz-border-radius: " +
            border_radius +
            "px;-webkit-border-radius: " +
            border_radius +
            "px;border-radius: " +
            border_radius +
            "px;" +
            "border: " +
            border_width +
            "px " +
            border_style +
            " " +
            border_color +
            ";" +
            shadow +
            " } ." +
            tx +
            " .meter span{-moz-border-radius: " +
            border_radius +
            "px;-webkit-border-radius: " +
            border_radius +
            "px;border-radius: " +
            border_radius +
            "px; }</style>"
        );
        jQuery("#anwcpb_preview ." + tx).append(
          '<p id="progress_bar' +
            tx +
            '"><div class="meter ' +
            theme +
            '"><span style="width: ' +
            (stage_scores[stage] == 100 ? "" : stage_scores[stage]) +
            "%;background-color:" +
            color +
            '"></span></div><div class="stage_names">' +
            stage_name_html +
            "</div></p><br><br>"
        );
      }
    }
  }
}

function shadeColor(color, percent) {
  var f = parseInt(color.slice(1), 16),
    t = percent < 0 ? 0 : 255,
    p = percent < 0 ? percent * -1 : percent,
    R = f >> 16,
    G = (f >> 8) & 0x00ff,
    B = f & 0x0000ff;
  return (
    "#" +
    (
      0x1000000 +
      (Math.round((t - R) * p) + R) * 0x10000 +
      (Math.round((t - G) * p) + G) * 0x100 +
      (Math.round((t - B) * p) + B)
    )
      .toString(16)
      .slice(1)
  );
}

function get_status_key(el) {
  var key = jQuery(el).attr("name");
  key = key.replace("anwc_order_progressbar[wc_statuses][success]", "");
  key = key.replace("anwc_order_progressbar[wc_statuses][failed]", "");
  key = key.replace("[", "");
  key = key.replace("]", "");
  return key;
}
function get_status_type(el) {
  var name = jQuery(el).attr("name");
  if (name.search("failed") >= 0) {
    return "failed";
  } else if (name.search("success") >= 0) {
    return "success";
  }
}

function get_stages_object() {
  var stages = { success: {}, failed: {} };
  jQuery("#wc_statuses input").each(function(i, el) {
    var type = get_status_type(el);

    var key = get_status_key(el);
    var status = jQuery(el).val();
    stages[type][key] = status;
  });
  return stages;
}
